<?php
/*
Plugin Name: YouTube SimpleGallery
Plugin URI: http://www.stianandreassen.com/plugins/youtube-simplegallery/
Description: A YouTube Gallery Plugin, that let's you add a gallery of videos to any Page or Post. Use [youtubegallery]{youtube-links}[/youtubegallery], with a list of YouTube-links separated with linebreaks to add a gallery. <strong>See <a href="options-general.php?page=youtube-gallery">Settings</a> for Usage.</strong>
Author: Stian Andreassen
Author URI: http://www.stianandreassen.com
Version: 1.2
*/

global $youtube_gallery_count, $youtube_gallery_ID;
$youtube_gallery_count = 0;
$youtube_gallery_ID = 0;

add_action('wp_head', 'youtube_gallery_css');

// ADD OPTIONS PAGE
add_action('admin_menu', 'youtubegallery_admin');
function youtubegallery_admin() {
  add_options_page('YouTube SimpleGallery', 'YouTube SimpleGallery', '10', 'youtube-gallery', 'youtubegallery_options');
  
  if($_REQUEST['action'] == 'update_youtube_gallery'){
  	delete_option('youtube_gallery_option');
	add_option('youtube_gallery_option', array('width' => $_REQUEST['youtubegallery_width'], 'height' => $_REQUEST['youtubegallery_height'], 'thickbox' => $_REQUEST['youtubegallery_thickbox'], 'openlinks' => $_REQUEST['youtubegallery_openlinks'], 'css' => $_REQUEST['youtubegallery_css'], 'title' => $_REQUEST['youtubegallery_title']));
  }
}

// Add settings link on plugin page  
function youtubegallery_settings_link($links) {  
$settings_link = '<a href="options-general.php?page=youtube-gallery">Settings</a>';  
array_push($links, $settings_link);  
return $links;  
}  

// SHOW OPTIONS
function youtubegallery_options(){
?>
<style type="text/css">
<!--
	#plugins td, #plugins th {
		border-bottom: none;
		padding: 10px;
	}
	
	#plugins th {
		text-align: right;
	}
	
	#plugins tr {
		vertical-align: top;
	}
	
	#thickboxstatus {
		float: left;
		width: 250px;
		border: 1px solid #dbdbdb;
		padding: 20px;
		margin-left: 20px;
		background: #ececec;
	}
	
	#youtube_settings {
		float: left;
	}
	
	.youtube_code {
		font-family: Consolas, Monaco, Courier, monospace;
		margin-left: 20px;
	}
	
	.youtube_highlight {
		background: #dedede;
	}
	
-->
</style>
<div id="wpbody-content">
	<div class="wrap">
		<div id="icon-options-general" class="icon32"><br /></div>
		<h2>YouTube Gallery Settings</h2>
		<br />
		<?php
	    if ( $_REQUEST['update'] ) echo '<div id="message" class="updated fade"><p><strong>Settings saved.</strong></p></div>';
		$youtube_gallery_options = get_option('youtube_gallery_option');
		?>
		
		<div id="youtube_settings">
		<form method="POST">
		<table class="widefat" id="plugins" style="width: 400px; clear: none;">
			<tbody>
				<tr>
					<th scope="row">Width:</th><td><input type="text" name="youtubegallery_width" size="6" value="<?php echo $youtube_gallery_options['width'] ?>"> <span style="color: #999;">Width of embedded video</span></td>
				</tr>
				<tr>
					<th scope="row">Height:</th><td><input type="text" name="youtubegallery_height" size="6" value="<?php echo $youtube_gallery_options['height'] ?>"> <span style="color: #999;">Height of embedded video</span></td>
				</tr>
				<tr>
					<th scope="row">Use&nbsp;JS:</th>
					<td>
						<input type="radio" name="youtubegallery_thickbox" value="shadowbox"<?php if($youtube_gallery_options['thickbox'] == 'shadowbox') echo' checked'; ?>> Shadowbox <br />
						<input type="radio" name="youtubegallery_thickbox" value="thickbox"<?php if($youtube_gallery_options['thickbox'] == 'thickbox') echo' checked'; ?>> Thickbox <br />
						<input type="radio" name="youtubegallery_thickbox" value="none"<?php if($youtube_gallery_options['thickbox'] == 'none') echo' checked'; ?>> None  | <input type="checkbox" name="youtubegallery_openlinks"<?php if($youtube_gallery_options['openlinks']) echo' checked'; ?>> Open links in new window/tab<br />
						<span style="color: #999;">Opens videos in a box on your page &ndash; requires either <a href="http://wordpress.org/extend/plugins/thickbox/">Thickbox</a> or <a href="http://wordpress.org/extend/plugins/shadowbox-js/">Shadowbox</a> installed. <br /><b>Select &#171;None&#187; if you want the links to go directly to the YouTube-page</b></span>
					</td>
				</tr>
				<tr>
					<th scope="row">Use&nbsp;CSS:</th><td><input type="checkbox" name="youtubegallery_css" value="usecss"<?php if($youtube_gallery_options['css'] == 'usecss') echo' checked'; ?>> <span style="color: #999;">Use CSS included with plugin<br /><b>Disable if you want to use your own CSS</b></span></td>
				</tr>
				<tr>
					<th scope="row">Display titles:</th><td><input type="radio" name="youtubegallery_title" value="above"<?php if($youtube_gallery_options['title'] == 'above') echo' checked'; ?>> Above thumbnails<br /><input type="radio" name="youtubegallery_title" value="below"<?php if($youtube_gallery_options['title'] == 'below') echo' checked'; ?>> Below thumbnails</td>
				</tr>
			</tbody>
		</table>
		<p class="submit">
		<input name="update" type="submit" value="<?php _e('Update Settings'); ?>" />
		<input type="hidden" name="action" value="update_youtube_gallery" />
		</p>
		</form>
		</div>
		
		<div id="thickboxstatus">
		<h3>Thickbox/Shadowbox status:</h3>		
		<p>
		<?php 
			if(function_exists('is_thickbox_enabled'))
			echo '<a href="http://wordpress.org/extend/plugins/thickbox/">Thickbox</a> is installed and activated';
			else
			echo 'Thickbox is NOT installed and/or not actived. Please download <a href="http://wordpress.org/extend/plugins/thickbox/">Thickbox</a>, install and activate it if you want to use it with this plugin.'; 
		?>
		</p>
		<p>
		<?php 
			if(class_exists('Shadowbox'))
			echo '<a href="http://wordpress.org/extend/plugins/shadowbox-js/">Shadowbox</a> is installed and activated';
			else
			echo 'Shadowbox is NOT installed and/or not actived. Please download <a href="http://wordpress.org/extend/plugins/shadowbox-js/">Shadowbox</a>, install and activate it if you want to use it with this plugin.'; 
		?>
		</p>
		</div>

		<h2 style="clear: both;">Usage</h2>
		<p>To embed a gallery in a Post or a Page use the following code:</p>
		<p class="youtube_code">
			[youtubegallery]<br />
			http://www.youtube.com/watch?v=KAixCRd7yYc<br />
			http://www.youtube.com/watch?v=xqTac_O_wh4<br />
			http://www.youtube.com/watch?v=jJK-G9-dLzw<br />
			[/youtubegallery]		
		</p>
		
		<p>If you want to add titles/description to the videos, add it before the link and separate with | (pipe), like this:</p>

		<p class="youtube_code">
			[youtubegallery]<br />
			<span class="youtube_highlight">Movie Buzz #187|</span>http://www.youtube.com/watch?v=KAixCRd7yYc<br />
			<span class="youtube_highlight">Call of Duty Modern Warfare: Deathmatch|</span>http://www.youtube.com/watch?v=xqTac_O_wh4<br />
			<span class="youtube_highlight">The Fast Show: Unlucky Alf|</span>http://www.youtube.com/watch?v=jJK-G9-dLzw<br />
			[/youtubegallery]		
		</p>
		
		<h2>Donate</h2>
		<p>Like this plugin? Please donate to support development.</p>
<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_s-xclick">
<input type="hidden" name="hosted_button_id" value="10406928">
<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
</form>
	</div>
</div>
<?php
}

// GET ONLY URL IF AUTO EMBED IS ON
function getAttribute($attrib, $tag){
  //get attribute from html tag
  $re = '/'.$attrib.'=["\']?([^"\' ]*)["\' ]/is';
  preg_match($re, $tag, $match);
  if($match){
    return urldecode($match[1]);
  }else {
    return false;
  }
}


// OUTPUT THE GALLERY
function show_youtubegallery( $atts, $youtubelinks = null ) {
$youtubelinks = explode("\n", $youtubelinks);
array_pop($youtubelinks);
array_shift($youtubelinks);

$youtubeoptions = get_option('youtube_gallery_option');
global $youtube_gallery_count, $youtube_gallery_ID;
$x = $youtube_gallery_count;
$youtube_gallery_ID++;
$showgallery = ('<div id="youtube_gallery_'.$youtube_gallery_ID.'" class="youtube_gallery"><div class="youtube_gallery_divider"></div><br />'."\n");
	foreach ( $youtubelinks as $thumbnails ):
		$x++;
		if(strstr($thumbnails, '|')) { $thumb = explode('|', $thumbnails); $captions = 'true'; }
		else { $thumb[1] = $thumbnails; $captions = ''; }

		if(get_option('embed_autourls')=='1' && !$captions){
		$tmpthumb = $thumb[1];
		$thumb[1] = getAttribute('value', $thumb[1]);
		$thumb[1] = str_replace('?fs=1', '', $thumb[1]);
			if(!$thumb[1]) {
				$thumb[1] = str_replace('watch?v=', 'v/', $tmpthumb);
			}
		}
		
		$thumb[1] = str_replace('&#8211;', '--', $thumb[1]);
		if(strstr($thumb[1], '&')) $thumb[1] = substr($thumb[1], 0, strpos($thumb[1], '&'));
		$thumb[1] = str_replace('http://www.youtube.com/watch?v=', '', $thumb[1]);
		$thumb[1] = str_replace('http://www.youtube.com/v/', '', $thumb[1]);		
		$thumb[1] = str_replace('<br />', '', $thumb[1]);
		$thumb[1] = str_replace('<p>', '', $thumb[1]);
		$thumb[1] = str_replace('</p>', '', $thumb[1]);		

		// IF USE SHADOWBOX
		if($youtubeoptions['thickbox'] == 'shadowbox') {
			$showgallery .= '<div id="youtube_gallery_item_'.$x.'" class="youtube_gallery_item">'."\n";
			if($youtubeoptions['title'] == 'above' && $thumb[0] ) $showgallery .= ('<p>'.$thumb[0].'</p>');
			$showgallery .= '<a rel="shadowbox;width='.($youtubeoptions['width']+10).';height='.($youtubeoptions['height']+30).';player=swf" href="http://www.youtube.com/v/'.str_replace("\r", '', $thumb[1]).'&amp;hl=en&amp;fs=1&amp;rel=0&amp;autoplay=1" title="'.$thumb[0].'"><img src="http://img.youtube.com/vi/'.str_replace("\r", '', $thumb[1]).'/default.jpg" border="0"></a><br />';
			if($youtubeoptions['title'] == 'below' && $thumb[0] ) $showgallery .= ('<p>'.$thumb[0].'</p>');
			$showgallery .='</div>'."\r";
		}

		// IF USE THICKBOX
		elseif($youtubeoptions['thickbox'] == 'thickbox') {
			$showgallery .= '<div id="youtube_gallery_item_'.$x.'" class="youtube_gallery_item">'."\n";
			if($youtubeoptions['title'] == 'above' && $thumb[0] ) $showgallery .= ('<p>'.$thumb[0].'</p>');
			$showgallery .= '<a href="#TB_inline?height='.($youtubeoptions['height']+30).'&width='.($youtubeoptions['width']+10).'&inlineId=youtubeplayer-'.$x.'" class="thickbox"><img src="http://img.youtube.com/vi/'.str_replace("\r", '', $thumb[1]).'/default.jpg" border="0"></a><br />';
			if($youtubeoptions['title'] == 'below' && $thumb[0] ) $showgallery .= ('<p>'.$thumb[0].'</p>');
			$showgallery .='</div>'."\r";
		}

		// IF GO TO YOUTUBE.COM
		else {
			$showgallery .= '<div id="youtube_gallery_item_'.$x.'" class="youtube_gallery_item">'."\n";
			if($youtubeoptions['title'] == 'above' && $thumb[0] ) $showgallery .= ('<p>'.$thumb[0].'</p>');
			$showgallery .= '<a href="http://www.youtube.com/watch?v='.str_replace('<br />', '', $thumb[1]).'"';
			if($youtubeoptions['openlinks']) $showgallery .= ' target="_blank"';
			$showgallery .= '><img src="http://img.youtube.com/vi/'.str_replace("\r", '', $thumb[1]).'/default.jpg" border="0"></a><br />';
			if($youtubeoptions['title'] == 'below' && $thumb[0] ) $showgallery .= ('<p>'.$thumb[0].'</p>');
			$showgallery .= '</div>'."\r";
		}
		unset($thumb[0]);
		unset($thumb[1]);
	endforeach;
	$showgallery .= ('<div class="youtube_gallery_divider"></div><br clear="all" /></div>');

if($youtubeoptions['thickbox'] == 'thickbox'):	
	$x = $youtube_gallery_count;
	reset($youtubelinks);
	foreach ( $youtubelinks as $videolink ):
		$x++;
		if(strstr($videolink, '|')) { $video = explode('|', $videolink); $captions = 'true'; }
		else { $video[1] = $videolink; $captions = ''; }

		if(get_option('embed_autourls')=='1' && !$captions ){
		$video[1] = getAttribute('value', $video[1]);
		$video[1] = str_replace('&#38;fs=1', '', $video[1]);
		}
		
		$video[1] = str_replace('&#8211;', '--', $video[1]);
		if(strstr($video[1], '&')) $video[1] = substr($video[1], 0, strpos($video[1], '&'));
		$video[1] = str_replace('watch?v=', 'v/', $video[1]);
		$video[1] = str_replace('<br />', '', $video[1]);
		$video[1] = str_replace('<p>', '', $video[1]);
		$showgallery .= '
		<div id="youtubeplayer-'.$x.'" style="display: none; text-align: center;"><br />
		<object width="'.$youtubeoptions['width'].'" height="'.$youtubeoptions['height'].'">
			<param name="movie" value="'.str_replace("\r", '', $video[1]).'&amp;hl=en_US&amp;fs=1&amp;"></param>
			<param name="allowFullScreen" value="true"></param>
			<param name="allowscriptaccess" value="always"></param>
			<embed src="'.str_replace("\r", '', $video[1]).'&amp;hl=en_US&amp;fs=1&amp;" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'.$youtubeoptions['width'].'" height="'.$youtubeoptions['height'].'"></embed>
		</object>
		</div>
		';
	endforeach;
endif;
$youtube_gallery_count = $x;
return $showgallery;
}
add_shortcode('youtubegallery', 'show_youtubegallery');

// ON INSTALL PLUGIN
function youtubegallery_install(){
		add_option('youtube_gallery_option', array('width' => '560', 'height' => '340', 'thickbox' => 'thickbox', 'css' => 'usecss', 'title' => 'below'));

}

// ON UNINSTALL PLUGIN
function youtubegallery_uninstall(){
		delete_option('youtube_gallery_option');

}

// ADD CSS TO FRONTEND AND SOME JQUERY FOR CENTERING
function youtube_gallery_css(){
global $youtube_gallery_ID;
$youtubeoptions = get_option('youtube_gallery_option');
if($youtubeoptions['css'] == 'usecss')
	echo("\n".'<link rel="stylesheet" href="'.get_bloginfo('home').'/wp-content/plugins/youtube-simplegallery/youtube_simplegallery.css" type="text/css" media="screen" />');
?>

<script type="text/javascript"> 
jQuery(document).ready(function($) {
	totalwidth = ($(".youtube_gallery").width());
	numberdivs = totalwidth/135;
	numberdivs = (numberdivs < 0 ? -1 : 1) * Math.floor(Math.abs(numberdivs))
	spacing = totalwidth - (135*numberdivs);
	$(".youtube_gallery").css({ 'margin-left' : (spacing/2), 'margin-right' : (spacing/2) });
});
</script>
<?php
}

// LOAD WORDPRESS’ BUILT-IN JQUERY
function yotube_gallery_init() {
		wp_enqueue_script('jquery');
		wp_enqueue_script('jquery-ui-core');
}
add_action('init', 'yotube_gallery_init');

// HOOK IT UP TO WORDPRESS
register_activation_hook(__FILE__,'youtubegallery_install');	
register_deactivation_hook(__FILE__,'youtubegallery_uninstall');	
add_filter("plugin_action_links_$plugin", 'youtubegallery_settings_link' ); 

?>
